wm title . " Basis of AI Backprop -- November 4, 1998 Student Version"

## geometry of the whole thing

set executable [info nameofexecutable]
if {$executable == "/usr/bin/wish"} {
# when started from C these are set by the C program
   set windwidth 620
   set windheight 460
   set upperleftx 0
   set upperlefty 0
   set currentfont 7
   set tkmaxlines 45
   set textcolor 2
   set backgroundcolor 5
   set cmdfilename "//"
   } \
else { sendgui }
set g [list $windwidth x $windheight + $upperleftx + $upperlefty]
set geom [join $g ""]
wm geometry . $geom

# WARNING:  I've tried composing a string for exec of the form:
#   exec xterm -e lynx /usr/local/doc/bp/bp.html
# but Tcl/Tk constantly reports it can't find the file and I
# don't know why.  This complicates producing a general string
# for other browsers, for netscape you would want:
#   exec netscape /usr/local/doc/bp/bp.html
# so changing to netscape requires more editing around every
# help call to exec.

set browser "lynx"
set htmlpath "/usr/local/doc/bp/"
set helpcmd [join [list $browser $htmlpath] " "]
set popupbuttonstyle raised
set buttonbuttonstyle raised

### canvas related items ###############

# fonts for the canvas

# When I upgraded to xfree86 v 3.3.1 vga disappeared and
# I don't know why, since it is there in my fonts directory.
# The quick fix is to replace it with another font.

#set fontname(1) VGA
#set fontcode(1) VGA
#set fonty(1) 15
#set fontx(1) 8

set fontname(1) "Courier 75-14"
set fontcode(1) -adobe-courier-medium-r-normal--14-140-75-75-m-90-iso8859-1
set fonty(1) 17
set fontx(1) 11

#set fontname(2) "Lucida 100-10"
#set fontcode(2) -b&h-lucidatypewriter-medium-r-normal-sans-14-100-100-100-m-80-iso8859-1
#set fonty(2) 15
#set fontx(2) 8

set fontname(2) "Courier 75-14 Bold"
set fontcode(2) -adobe-courier-bold-r-normal--14-*-75-75-m-*-*1
set fonty(2) 15
set fontx(2) 8

set fontname(3) "Courier 75-18"
set fontcode(3) -adobe-courier-medium-r-normal--18-180-75-75-m-110-iso8859-1
set fonty(3) 19
set fontx(3) 8

#set fontname(3) "Lucida 100-12"
#set fontcode(3) -b&h-lucidatypewriter-medium-r-normal-sans-17-120-100-100-m-100-iso8859-1
#set fonty(3) 17
#set fontx(3) 10

set fontname(4) "Courier 75-18 Bold"
set fontcode(4) -adobe-courier-bold-r-normal--18-*-75-75-m-*-*
set fonty(4) 17
set fontx(4) 10

set fontname(5) "Terminal 14 Bold"
set fontcode(5) -dec-terminal-bold-r-normal--14-140-75-75-c-80-iso8859-1
set fonty(5) 14
set fontx(5) 10

#set fontname(4) "Lucida 100-14"
#set fontcode(4) -b&h-lucidatypewriter-medium-r-normal-sans-20-140-100-100-m-120-iso8859-1
#set fonty(4) 19
#set fontx(4) 12

#set fontname(5) "Lucida 100-18"
#set fontcode(5) -b&h-lucidatypewriter-medium-r-normal-sans-25-180-100-100-m-150-iso8859-1
#set fonty(5) 23
#set fontx(5) 15

set fontname(6) "Lucida 75-14"
set fontcode(6) -b&h-lucidatypewriter-medium-r-normal-sans-14-140-75-75-m-90-iso8859-1
set fonty(6) 15
set fontx(6) 9

set fontname(7) "Lucida 75-18"
set fontcode(7) -b&h-lucidatypewriter-medium-r-normal-sans-18-180-75-75-m-110-iso8859-1
set fonty(7) 20
set fontx(7) 11

# margins for the canvas

set leftmargin 5
set rightmargin 5
set topmargin 3
set bottommargin 5

# colors for the canvas

set bgcolorname(1) White
set bgcolorcode(1) white
set bgcolorname(2) "White Smoke"
set bgcolorcode(2) WhiteSmoke
set bgcolorname(3) "Papaya Whip"
set bgcolorcode(3) PapayaWhip
set bgcolorname(4) Gray
set bgcolorcode(4) gray
set bgcolorname(5) "Royal Blue 4"
set bgcolorcode(5) RoyalBlue4
set bgcolorname(6) "Midnight Blue"
set bgcolorcode(6) MidnightBlue
set bgcolorname(7) Black
set bgcolorcode(7) black

set textcolorname(1) Black
set textcolorcode(1) black
set textcolorname(2) White
set textcolorcode(2) white
set textcolorname(3) Green
set textcolorcode(3) green
set textcolorname(4) Orange
set textcolorcode(4) orange
set textcolorname(5) Yellow
set textcolorcode(5) yellow

set linenumber 0
set newlinehere 0
set minimumlines 45

set stoptrain 0
set widestline 1
set scrollheight [expr $tkmaxlines * $fonty($currentfont) + $topmargin +$bottommargin]
set scrollwidth [expr $widestline * $fontx($currentfont) + $leftmargin]

# entry box stuff

set entryboxfont $fontcode(1)

### menu related options for the canvas ###############

# dialog.tcl --
#
# This file defines the procedure tk_dialog, which creates a dialog
# box containing a bitmap, a message, and one or more buttons.
#
# SCCS: @(#) dialog.tcl 1.25 96/04/10 15:43:33
#
# Copyright (c) 1992-1993 The Regents of the University of California.
# Copyright (c) 1994-1996 Sun Microsystems, Inc.
#
# See the file "license.terms" for information on usage and redistribution
# of this file, and for a DISCLAIMER OF ALL WARRANTIES.
#

#
# my_dialog:
#
# This procedure displays a dialog box, waits for a button in the dialog
# to be invoked, then returns the index of the selected button.
#
# Arguments:
# w -		Window to use for dialog top-level.
# title -	Title to display in dialog's decorative frame.
# text -	Message to display in dialog.
# bitmap -	Bitmap to display in dialog (empty string means none).
# default -	Index of button that is to display the default ring
#		(-1 means none).
# args -	One or more strings to display in buttons across the
#		bottom of the dialog box.

proc my_dialog {w title text bitmap default args} {
    global tkPriv

    # 1. Create the top-level window and divide it into top
    # and bottom parts.

    catch {destroy $w}
    toplevel $w -class Dialog
    wm title $w $title
    wm iconname $w Dialog
    wm protocol $w WM_DELETE_WINDOW { }

    # The following command has been removed because if it is present
    # the dialog won't be posted if [winfo parent $w] is iconified.

#    wm transient $w [winfo toplevel [winfo parent $w]]
    frame $w.bot -relief raised -bd 1
    pack $w.bot -side bottom -fill both
    frame $w.top -relief raised -bd 1
    pack $w.top -side top -fill both -expand 1

    # 2. Fill the top part with bitmap and message (use the option
    # database for -wraplength so that it can be overridden by
    # the caller).

    option add *Dialog.msg.wrapLength 3i widgetDefault
    label $w.msg -justify left -text $text
    catch {$w.msg configure -font \
		-Adobe-Times-Medium-R-Normal--*-180-*-*-*-*-*-*
    }
    pack $w.msg -in $w.top -side right -expand 1 -fill both -padx 3m -pady 3m
    if {$bitmap != ""} {
	label $w.bitmap -bitmap $bitmap
	pack $w.bitmap -in $w.top -side left -padx 3m -pady 3m
    }

    # 3. Create a row of buttons at the bottom of the dialog.

    set i 0
    foreach but $args {
	button $w.button$i -text $but -command "set tkPriv(button) $i"
	if {$i == $default} {
	    frame $w.default -relief sunken -bd 1
	    raise $w.button$i $w.default
	    pack $w.default -in $w.bot -side left -expand 1 -padx 3m -pady 2m
	    pack $w.button$i -in $w.default -padx 2m -pady 2m
	} else {
	    pack $w.button$i -in $w.bot -side left -expand 1 \
		    -padx 3m -pady 2m
	}
	incr i
    }

    # 4. Create a binding for <Return> on the dialog if there is a
    # default button.

    if {$default >= 0} {
	bind $w <Return> "
	    $w.button$default configure -state active -relief sunken
	    update idletasks
	    after 100
	    set tkPriv(button) $default
	"
    }

    # 5. Withdraw the window, then update all the geometry information
    # so we know how big it wants to be, then center the window in the
    # display and de-iconify it.

    wm withdraw $w
    update idletasks
    set x [expr [winfo screenwidth $w]/2 - [winfo reqwidth $w]/2 \
	    - [winfo vrootx [winfo parent $w]]]
    set y [expr [winfo screenheight $w]/2 - [winfo reqheight $w]/2 \
	    - [winfo vrooty [winfo parent $w]]]
    set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $w]/2]
    set y [expr [winfo height .] /2 + [winfo rooty .] - [winfo reqheight $w]/2]
    wm geom $w +$x+$y
    wm deiconify $w

    # 6. Set a grab and claim the focus too.

    set oldFocus [focus]
    set oldGrab [grab current $w]
    if {$oldGrab != ""} {
	set grabStatus [grab status $oldGrab]
    }
    grab $w
    if {$default >= 0} {
	focus $w.button$default
    } else {
	focus $w
    }

    # 7. Wait for the user to respond, then restore the focus and
    # return the index of the selected button.  Restore the focus
    # before deleting the window, since otherwise the window manager
    # may take the focus away so we can't redirect it.  Finally,
    # restore any grab that was in effect.

    tkwait variable tkPriv(button)
    catch {focus $oldFocus}
    destroy $w
    if {$oldGrab != ""} {
	if {$grabStatus == "global"} {
	    grab -global $oldGrab
	} else {
	    grab $oldGrab
	}
    }
    return $tkPriv(button)
}

proc getval {heading op} {
global varval
global newval
global entryboxfont
global operation
set operation $op
set newval .x2
toplevel $newval
set x [expr [winfo width .]/2 + [winfo rootx .] - 250 / 2]
set y [expr [winfo height .]/2 + [winfo rooty .] - 30 / 2]
wm geometry $newval 250x30+$x+$y
#wm geometry $newval 200x30+100+100
wm title $newval $heading
frame $newval.file
set varval ""
entry $newval.file.entry -width 30 -font $entryboxfont -textvariable varval
pack $newval.file.entry -side left
bind $newval.file.entry <Return> \
   { set cmdlist4 [list $operation $varval];
     set cmd4 [join $cmdlist4 " "];
     ccmd $cmd4;
     destroy $newval }
pack $newval.file
focus $newval.file.entry
}

proc getval2 {heading} {
global val2
global entryboxfont
global newval2
set newval2 .x1
toplevel $newval2
set x [expr [winfo width .]/2 + [winfo rootx .] - 250 / 2]
set y [expr [winfo height .]/2 + [winfo rooty .] - 30 / 2]
wm geometry $newval2 250x30+$x+$y
wm title $newval2 $heading
frame $newval2.file
set val2 ""
entry $newval2.file.entry -width 30 -font $entryboxfont -textvariable val2
pack $newval2.file.entry -side left
bind $newval2.file.entry <Return> { destroy $newval2 }
pack $newval2.file
focus $newval2.file.entry
}

proc more {} {
#after idle {.dialog1.msg configure -wraplength 4i}
set i [my_dialog .dialog1 " More?" {More?} \
{} 0 {Another Page} {One Line} {Half Page} {Stop Paging} {Break Loop}]

switch $i {
    0 {return 0}
    1 {return 1}
    2 {return 2}
    3 {return 3}
    4 {return 4}
}
}

proc getgeom {} {
set xlist [list [winfo width .] [winfo height .] [winfo rootx .] [winfo rooty .]]
set xstr [join $xlist " "]
return $xstr
}

proc error {message} {
set i [my_dialog .dialog1 " Error" $message {} 0 OK]
tkwait window .dialog1
switch $i {0 {return}}
}

proc settext {newline} {
global widestline
global scrollwidth
global scrollheight
global txt
global tkmaxlines
global newlinehere
global textheight
global windheight
global frameheight
global entryboxheight
global leftmargin
global currentfont
global ybottom
global textcolor
global textcolorcode
global fonty
global fontcode
global ybottom
.textarea.can delete $newlinehere
set deltay [expr 0 - $fonty($currentfont)]
.textarea.can move all 0 $deltay
set txt($newlinehere) $newline
.textarea.can create text $leftmargin $ybottom -text $newline -anchor nw -font $fontcode($currentfont) -tags $newlinehere -fill $textcolorcode($textcolor)
incr newlinehere 1
if { $newlinehere == $tkmaxlines } { set newlinehere 0 }

# dealing with a longer string

set linelen [string length $newline]
if {$linelen > $widestline} { set widestline $linelen; displaytext $currentfont }
update idletasks
}

proc displaytext {FONT} {
global txt
global tkmaxlines
global windheight
global frameheight
global newlinehere
global entryboxheight
global leftmargin
global rightmargin
global scrollwidth
global scrollheight
global ybottom
global canvas_height
global canvas_width
global topmargin
global bottommargin
global widestline
global textcolor
global textcolorcode
global fonty
global fontx
global fontcode
global currentfont
.textarea.can delete all
set currentfont $FONT
set ybottom [expr ($tkmaxlines - 1) * $fonty($currentfont) + $topmargin]
set scrollheight [expr $tkmaxlines * $fonty($currentfont) + $topmargin + $bottommargin]
set scrollwidth [expr $widestline * $fontx($currentfont) + $leftmargin + $rightmargin]
set dumblist [list 0 0 $scrollwidth $scrollheight]
.textarea.can configure -scrollregion $dumblist
set diff [expr $scrollheight - $canvas_height]
set fraction_off_above [expr 1.0 * $diff / $scrollheight]
.textarea.can yview moveto $fraction_off_above

set linenumber $newlinehere
if {$linenumber == $tkmaxlines} {set linenumber 0}
set y $topmargin
set count 0
while { $count < $tkmaxlines } {
   .textarea.can create text $leftmargin $y -text $txt($linenumber) -anchor nw -font $fontcode($currentfont) -tags $linenumber -fill $textcolorcode($textcolor)
   incr linenumber 1
   if {$linenumber == $tkmaxlines} {set linenumber 0}
   set y [expr $y + $fonty($currentfont)]
   incr count 1
   }
}


proc newmaxlines {newtkmaxlines} {
global tkmaxlines
global txt
global newlinehere
global minimumlines
global currentfont
if {$newtkmaxlines == $tkmaxlines} {return}
if {$newtkmaxlines < $minimumlines} {error "The Minimum is 45"; return}
set oldtkmaxlines $tkmaxlines
#
# make a copy of the lines in tbuf (makes dealing with subscripts easier)
#
set i $newlinehere
set count 0;
while {$count < $oldtkmaxlines} {
   set tbuf($count) $txt($i)
   incr count 1
   incr i 1
   if {$i == $oldtkmaxlines} {set i 0}
   }

# fewer lines, fill in txt with lines from tbuf
if {$newtkmaxlines < $oldtkmaxlines} {
   set j 0
   set i [expr $oldtkmaxlines - $newtkmaxlines]
   while { $j < $newtkmaxlines } {
      set txt($j) $tbuf($i)
      incr j 1
      incr i 1
      }
} elseif { $newtkmaxlines > $oldtkmaxlines} {
# new lines at the top are blanked out
   set diff [expr $newtkmaxlines - $oldtkmaxlines]
   set i 0
   while {$i < $diff} {
      set txt($i) " "
      incr i 1
      }
   set j $diff
   set i 0
   while { $j < $newtkmaxlines } {
      set txt($j) $tbuf($i)
      incr i 1
      incr j 1
      }
   }
set tkmaxlines $newtkmaxlines
set newlinehere 0
displaytext $currentfont
}

# change a menu entry, mu = menu update, currently unused

proc mu {wind n newtext} {
$wind entryconfigure $n -label $newtext
}

proc send {alist} {
set temp [join $alist " "]
ccmd $temp}

proc nmenu {} {
global z9
global entryboxfont popupbuttonstyle
global outformat ioconnects elmantext stmsize
global textoutformat layerno
global var2
set z9 .z9
toplevel $z9

sendnetsize

label $z9.msg -text "Change Parameters\nIssue Commands" -foreground red -background white -height 3
pack $z9.msg -side top

if {$nlayers == 0} {
label $z9.msg2 -text "No Network" -foreground red -background white -height 1 } \
elseif {$nlayers == 2} {
   set sizelist [list "Two Layers: " $ninput $noutput]
   set size [join $sizelist " "]
   label $z9.msg2 -text $size -foreground red -background white -height 1 } \
elseif {$nlayers == 3} {
   set sizelist [list "Three Layers: " $ninput $n1hidden $noutput]
   set size [join $sizelist " "]
   label $z9.msg2 -text $size -foreground red -background white -height 1 } \
else {
   set sizelist [list "Four Layers: " $ninput $n1hidden $n2hidden $noutput]
   set size [join $sizelist " "]
   label $z9.msg2 -text $size -foreground red -background white -height 1 }
pack $z9.msg2

if {$ioconnects == "Yes"} {
   label $z9.msg3 -text "With Direct I/O Connections" -foreground red -background white -height 1} \
else {label $z9.msg3 -text "No Direct I/O Connections" -foreground red -background white -height 1}
pack $z9.msg3

wm title $z9 " Network Commands"
set fudgefactor 100

if {$outformat == "c"} {set textoutformat Compressed} \
elseif {$outformat == "a"} {set textoutformat "Analog Compressed"} \
elseif {$outformat == "r"} {set textoutformat "Real (F-Format)"} \
else {set textoutformat "E-Format"} \

button $z9.make2 -text "Make a Two Layer Network" -width 26 \
   -command {mktwolayer; destroy $z9}
pack $z9.make2

button $z9.make3 -text "Make a Three Layer Network" -width 26 \
   -command {mkthreelayer; destroy $z9}
pack $z9.make3

button $z9.make4 -text "Make a Four Layer Network" -width 26 \
   -command {mkfourlayer; destroy $z9}
pack $z9.make4

frame $z9.outformat
menubutton $z9.outformat.label -text "Format for Pattern Printing" -width 24 \
   -menu $z9.outformat.label.menu -relief $popupbuttonstyle
entry $z9.outformat.entry -width 17 -font $entryboxfont -textvariable textoutformat
pack $z9.outformat.label $z9.outformat.entry -side left
pack $z9.outformat

menu $z9.outformat.label.menu
$z9.outformat.label.menu add command -label "Analog Compressed" \
   -command { set outformat a; set textoutformat "Analog Compressed"; ccmd "f oa"}
$z9.outformat.label.menu add separator
$z9.outformat.label.menu add command -label "Compressed" \
   -command { set outformat c; set textoutformat "Compressed"; ccmd "f oc" }
$z9.outformat.label.menu add separator
$z9.outformat.label.menu add command -label "E-Format" \
   -command { set outformat e; set textoutformat "E-Format"; ccmd "f oe" }
$z9.outformat.label.menu add separator
$z9.outformat.label.menu add command -label "Real (F- Format)" \
   -command { set outformat r; set textoutformat "Real(F-Format)"; ccmd "f or" }

button $z9.typeeval -text "Type in and Load a Pattern" -width 26 \
   -command { getval "Type Pattern" "\\" }
pack $z9.typeeval

button $z9.listtrain -text "Load Training Set Pattern" -width 26 \
   -command { getval "Give Pattern Number" p }
pack $z9.listtrain

button $z9.onetest -text "Load Test Set Pattern" -width 26 \
   -command { getval "Give Pattern Number" t }
pack $z9.onetest

set layerno ""
frame $z9.layer
label $z9.layer.label -text "List Units on Layer:" -width 24 
entry $z9.layer.entry -width 17 -font $entryboxfont -textvariable layerno
bind $z9.layer.entry <Return> {send [list l $layerno]}
pack $z9.layer.label $z9.layer.entry -side left
pack $z9.layer

frame $z9.buttons
button $z9.buttons.help -text "Help" -width 6 \
   -command {exec xterm -e $browser [join [list $htmlpath N.html] ""];
             destroy $z9 }
button $z9.buttons.exit -text "Exit" -width 6 -command { destroy $z9 }
pack $z9.buttons.help $z9.buttons.exit -side left
pack $z9.buttons

set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $z9]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $z9]/2 - $fudgefactor]
wm geometry $z9 +$x+$y
}

proc patmenu {} {
global y9
global entryboxfont popupbuttonstyle
global echo textecho informat globalfilename
global probtype wtfilename
global textinformat
global textprobtype
global var2
set y9 .y9
toplevel $y9

label $y9.msg -text "Change Parameters\nIssue Commands" -foreground red -background white -height 3
pack $y9.msg -side top

wm title $y9 " Pattern Related Commands"
set fudgefactor 120

sendpmenu

if {$informat == "c"} {set textinformat Compressed} else {set textinformat Real}
if {$probtype == "c"} {set textprobtype Classification } \
else {set textprobtype General}

frame $y9.informat
button $y9.informat.label -text "Pattern Input Format" -width 17 \
   -command { if {$informat == "c"} \
                 {set informat r;
                  set textinformat "Real";
                  ccmd "f ir"} \
              else {set informat c;
                    set textinformat "Compressed";
                    ccmd "f ic" }}
entry $y9.informat.entry -width 17 -font $entryboxfont -textvariable textinformat
pack $y9.informat.label $y9.informat.entry -side left
pack $y9.informat

frame $y9.probtype
button $y9.probtype.label -text "Problem Type" -width 17 \
   -command { if {$probtype == "c"} \
                 {set probtype g;
                  set textprobtype "General";
                  ccmd "f pg"} \
              else {set probtype c;
                    set textprobtype "Classification";
                    ccmd "f pc" }}
entry $y9.probtype.entry -width 17 -font $entryboxfont -textvariable textprobtype
pack $y9.probtype.label $y9.probtype.entry -side left
pack $y9.probtype

button $y9.readtrain -text "Read Training Set Patterns" -width 26 \
   -command { filelistbox rt}
pack $y9.readtrain

button $y9.readmoretrain -text "Read More Training Set Patterns" -width 26 \
   -command { filelistbox rx}
pack $y9.readmoretrain

button $y9.readtest -text "Read Test Set Patterns" -width 26 \
   -command { filelistbox tf}
pack $y9.readtest

button $y9.typeeval -text "Type in and Evaluate a Pattern" -width 26 \
   -command { getval "Type Pattern" "\\" }
pack $y9.typeeval

frame $y9.trainset
label $y9.trainset.label -text "Print Training Set" -width 15
button $y9.trainset.p0 -text "Summary" -command { ccmd p0 }
button $y9.trainset.p -text "All" -command { ccmd p }
button $y9.trainset.one -text "One"  \
   -command { getval "Give Pattern Number" p }
button $y9.trainset.target -text "Target"  \
   -command { getval "Give Pattern Number" pt }
pack $y9.trainset.label $y9.trainset.p0 $y9.trainset.p \
     $y9.trainset.one $y9.trainset.target -side left
pack $y9.trainset

frame $y9.testset
label $y9.testset.label -text "Print Test Set" -width 15
button $y9.testset.t0 -text "Summary" -command { ccmd t0 }
button $y9.testset.t -text "All" -command { ccmd t }
button $y9.testset.one -text "One" \
   -command { getval "Give Pattern Number" t }
button $y9.testset.target -text "Target" \
   -command { getval "Give Pattern Number" tt }
pack $y9.testset.label $y9.testset.t0 $y9.testset.t \
     $y9.testset.one $y9.testset.target -side left
pack $y9.testset

button $y9.oddrecur -text "The Odd Recurrent Network Test" -width 26 \
   -command { getval "Give Length of Sequence" tr }
pack $y9.oddrecur

button $y9.oddrecurp -text "The Odd Test With Printing" -width 26 \
   -command { getval "Give Length of Sequence" trp }
pack $y9.oddrecurp

frame $y9.buttons
button $y9.buttons.help -text "Help" -width 6 -command { destroy $y9 }
button $y9.buttons.exit -text "Exit" -width 6 -command { destroy $y9 }
pack $y9.buttons.help $y9.buttons.exit -side left
pack $y9.buttons

set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $y9]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $y9]/2 - $fudgefactor]
wm geometry $y9 +$x+$y
}

proc imenu {} {
global y8
global entryboxfont popupbuttonstyle
global echo textecho informat globalfilename
global probtype wtfilename unknown oldunknown
global textinformat
global textprobtype
global var2
set y8 .y8
toplevel $y8

label $y8.msg -text "Change Parameters\nRead Files" -foreground red -background white -height 3
pack $y8.msg -side top

wm title $y8 " Input Parameters and Functions"
set fudgefactor 100

sendimenu
set oldunknown $unknown

if {$echo == "+"} {set textecho Yes} else {set textecho No}
if {$informat == "c"} {set textinformat Compressed} else {set textinformat Real}
if {$probtype == "c"} {set textprobtype Classification } \
else {set textprobtype General}

frame $y8.echo
button $y8.echo.label -text "Echo Input" -width 17 \
   -command { if {$echo == "+"} \
                 {set echo "-"; set textecho No} \
              else {set echo "+"; set textecho Yes};
              send [list fe $echo]}
entry $y8.echo.entry -width 17 -font $entryboxfont -textvariable textecho
pack $y8.echo.label $y8.echo.entry -side left
pack $y8.echo

frame $y8.informat
button $y8.informat.label -text "Pattern Input Format" -width 17 \
   -command { if {$informat == "c"} \
                 {set informat r;
                  set textinformat "Real";
                  ccmd "f ir"} \
              else {set informat c;
                    set textinformat "Compressed";
                    ccmd "f ic" }}
entry $y8.informat.entry -width 17 -font $entryboxfont -textvariable textinformat
pack $y8.informat.label $y8.informat.entry -side left
pack $y8.informat

frame $y8.unknown
label $y8.unknown.label -width 20 -text "The value of x"
entry $y8.unknown.entry -width 17 -font $entryboxfont -textvariable unknown
bind $y8.unknown.entry <Return> {send [list "f x" $unknown]}
pack $y8.unknown.label $y8.unknown.entry -side left
pack $y8.unknown

frame $y8.probtype
button $y8.probtype.label -text "Problem Type" -width 17 \
   -command { if {$probtype == "c"} \
                 {set probtype g;
                  set textprobtype "General";
                  ccmd "f pg"} \
              else {set probtype c;
                    set textprobtype "Classification";
                    ccmd "f pc" }}
entry $y8.probtype.entry -width 17 -font $entryboxfont -textvariable textprobtype
pack $y8.probtype.label $y8.probtype.entry -side left
pack $y8.probtype

button $y8.dir -text "Change Directory" -width 26 \
   -command { getval "New Directory:" "cd"}
pack $y8.dir

button $y8.readcmds -text "Read Commands File" -width 26 \
   -command { filelistbox i; destroy $y8}
pack $y8.readcmds

button $y8.readtrain -text "Read Training Set Patterns" -width 26 \
   -command { filelistbox rt}
pack $y8.readtrain

button $y8.readmoretrain -text "Read More Training Set Patterns" -width 26 \
   -command { filelistbox rx}
pack $y8.readmoretrain

button $y8.readtest -text "Read Test Set Patterns" -width 26 \
   -command { filelistbox tf}
pack $y8.readtest

frame $y8.readwts
button $y8.readwts.label -text "Read Weights From:" -width 17 \
   -command {send [list rw $wtfilename]}
entry $y8.readwts.entry -width 17 -font $entryboxfont \
   -textvariable wtfilename -fg red -bg white
pack $y8.readwts.label $y8.readwts.entry -side left
pack $y8.readwts

button $y8.readwts2 -text "Read Weights, List Files" -width 26 \
   -command { filelistbox rw; tkwait window $xxx; set wtfilename $globalfilename}
pack $y8.readwts2

frame $y8.buttons
button $y8.buttons.help -text "Help" -width 6 \
   -command { exec xterm -e $browser [join [list $htmlpath F.html] ""] }
button $y8.buttons.change -text "Change" -width 6 \
   -command { if { $oldunknown != $unknown} \
                 { send [list "f x" $unknown};
              destroy $y8 }
button $y8.buttons.exit -text "Cancel" -width 6 -command { destroy $y8 }
pack $y8.buttons.help $y8.buttons.change $y8.buttons.exit -side left
pack $y8.buttons

set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $y8]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $y8]/2 - $fudgefactor]
wm geometry $y8 +$x+$y
}

proc fmenu {} {
global y7
global entryboxfont popupbuttonstyle
global copyfilename echo textecho copyflag informat errormessages outformat
global probtype runningflag summary up_to_date_stats unknown
global format oldunknown oldformat
global textcopyflag textinformat texterrormes textoutformat
global textprobtype textrunning textsummary textuptodate
global pagesize oldpagesize
set y7 .y7
toplevel $y7

label $y7.msg -text "Change Format Parameters" -foreground red -background white -height 2
pack $y7.msg -side top

wm title $y7 " Format Options"
set fudgefactor 140

sendfmenu
set oldunknown $unknown
set oldformat $format


if {$echo == "+"} {set textecho Yes} else {set textecho No}
if {$copyflag == "+"} {set textcopyflag Yes} else {set textcopyflag No}
if {$informat == "c"} {set textinformat Compressed} else {set textinformat Real}
if {$errormessages == "b"} {set texterrormes Both} \
elseif {$errormessages == "w"} {set texterrormes Window} \
else {set texterrormes Teletype}
if {$outformat == "a"} {set textoutformat "Analog Compressed"} \
elseif {$outformat == "c"} {set textoutformat Compressed} \
elseif {$outformat == "e"} {set textoutformat "E Format"} \
else {set textoutformat "F Format"}
#if {$offby1 == "+"} {set textoffby1 Yes} else {set textoffby1 No}
if {$probtype == "c"} {set textprobtype Classification } \
else {set textprobtype General}
if {$runningflag == "+"} {set textrunning Yes} else {set textrunning No}
if {$summary == "+"} {set textsummary Yes} else {set textsummary No}
if {$up_to_date_stats == "+"} {set textuptodate Yes} else {set textuptodate No}


frame $y7.informat
button $y7.informat.label -text "Pattern Input Format" -width 40 \
   -command { if {$informat == "c"} \
                 {set informat r;
                  set textinformat "Real";
                  ccmd "f ir"} \
              else {set informat c;
                    set textinformat "Compressed";
                    ccmd "f ic" }}
entry $y7.informat.entry -width 17 -font $entryboxfont -textvariable textinformat
pack $y7.informat.label $y7.informat.entry -side left
pack $y7.informat

frame $y7.unknown
label $y7.unknown.label -width 43 -text "The value of x in Patterns"
entry $y7.unknown.entry -width 17 -font $entryboxfont -textvariable unknown
bind $y7.unknown.entry <Return> {send [list "f x" $unknown]}
pack $y7.unknown.label $y7.unknown.entry -side left
pack $y7.unknown

frame $y7.probtype
button $y7.probtype.label -text "Problem Type" -width 40 \
   -command { if {$probtype == "c"} \
                 {set probtype g;
                  set textprobtype "General";
                  ccmd "f pg"} \
              else {set probtype c;
                    set textprobtype "Classification";
                    ccmd "f pc" }}
entry $y7.probtype.entry -width 17 -font $entryboxfont -textvariable textprobtype
pack $y7.probtype.label $y7.probtype.entry -side left
pack $y7.probtype

#frame $y7.offby1
#button $y7.offby1.label -text "Use Off By 1 Stats" -width 40 \
#   -command { if {$offby1 == "+"} \
#                 {set offby1 "-"; set textoffby1 No} \
#              else {set offby1 "+"; set textoffby1 Yes};
#              send [list fO $offby1]}
#entry $y7.offby1.entry -width 17 -font $entryboxfont -textvariable textoffby1
#pack $y7.offby1.label $y7.offby1.entry -side left
#pack $y7.offby1

frame $y7.outformat
menubutton $y7.outformat.label -text "Format for Pattern Printing" -width 42 \
   -menu $y7.outformat.label.menu -relief $popupbuttonstyle
entry $y7.outformat.entry -width 17 -font $entryboxfont -textvariable textoutformat
pack $y7.outformat.label $y7.outformat.entry -side left
pack $y7.outformat
# error message format menu
menu $y7.outformat.label.menu
$y7.outformat.label.menu add command -label "Analog Compressed" \
   -command { set outformat a; set textoutformat "Analog Compressed"; ccmd "f oa"}
$y7.outformat.label.menu add separator
$y7.outformat.label.menu add command -label "Compressed" \
   -command { set outformat c; set textoutformat "Compressed"; ccmd "f oc" }
$y7.outformat.label.menu add separator
$y7.outformat.label.menu add command -label "E-Format" \
   -command { set outformat e; set textoutformat "E-Format"; ccmd "f oe" }
$y7.outformat.label.menu add separator
$y7.outformat.label.menu add command -label "Real (F- Format)" \
   -command { set outformat r; set textoutformat "Real(F-Format)"; ccmd "f or" }

frame $y7.breaks
label $y7.breaks.label -width 56 -text "The Places to Insert Breaks When Printing Patterns:"
entry $y7.breaks.entry -width 56 -font $entryboxfont -textvariable format
bind $y7.breaks.entry <Return> {send [list "f B" $format]}
pack $y7.breaks.label
pack $y7.breaks.entry
pack $y7.breaks

#frame $y7.copyflag
#button $y7.copyflag.label -text "Copying I/O" -width 40 \
#   -command { if {$echo == "+"} \
#                 {set copyflag "-"; set copyflag No} \
#              else {set textcopyflag "+"; set textcopyflag Yes};
#              send [list "fc" $copyflag]}
#entry $y7.copyflag.entry -width 17 -font $entryboxfont -textvariable textcopyflag
#pack $y7.copyflag.label $y7.copyflag.entry -side left
#pack $y7.echo

frame $y7.errormes
menubutton $y7.errormes.label -text "Form of Error Messages" -width 42 \
   -menu $y7.errormes.label.menu -relief $popupbuttonstyle
entry $y7.errormes.entry -width 17 -font $entryboxfont -textvariable texterrormes
pack $y7.errormes.label $y7.errormes.entry -side left
pack $y7.errormes
# error message format menu
menu $y7.errormes.label.menu
$y7.errormes.label.menu add command -label "Window" \
   -command { set errormessages w; set texterrormes "Window"; ccmd "f Ew"}
$y7.errormes.label.menu add separator
$y7.errormes.label.menu add command -label "Teletype" \
   -command { set errormessages t; set texterrormes "Teletype"; ccmd "f Et" }
$y7.errormes.label.menu add separator
$y7.errormes.label.menu add command -label "Both" \
   -command { set errormessages b; set texterrormes "Both"; ccmd "f Eb" }

frame $y7.echo
button $y7.echo.label -text "Echo Input" -width 40 \
   -command { if {$echo == "+"} \
                 {set echo "-"; set textecho No} \
              else {set echo "+"; set textecho Yes};
              send [list fe $echo]}
entry $y7.echo.entry -width 17 -font $entryboxfont -textvariable textecho
pack $y7.echo.label $y7.echo.entry -side left
pack $y7.echo

frame $y7.pagesize
label $y7.pagesize.label -width 43 -text "Page Size"
entry $y7.pagesize.entry -width 17 -font $entryboxfont -textvariable pagesize
bind $y7.pagesize.entry <Return> {send [list fP $pagesize]; set oldpagesize $pagesize}
pack $y7.pagesize.label $y7.pagesize.entry -side left
pack $y7.pagesize

frame $y7.running
button $y7.running.label -text "Print Running ... Message" -width 40 \
   -command { if {$runningflag == "+"} \
                 {set runningflag "-"; set textrunning No} \
              else {set runningflag "+"; set textrunning Yes};
              send [list fR $runningflag]}
entry $y7.running.entry -width 17 -font $entryboxfont -textvariable textrunning
pack $y7.running.label $y7.running.entry -side left
pack $y7.running

frame $y7.summary
button $y7.summary.label -text "Summarize Status When Training" -width 40 \
   -command { if {$summary == "+"} \
                 {set summary "-"; set textsummary No} \
              else {set summary "+"; set textsummary Yes};
              send [list fs $summary]}
entry $y7.summary.entry -width 17 -font $entryboxfont -textvariable textsummary
pack $y7.summary.label $y7.summary.entry -side left
pack $y7.summary

frame $y7.uptodate
button $y7.uptodate.label -text "Compute Up-To-Date Status of Training Patterns" -width 40 \
   -command { if {$up_to_date_stats == "+"} \
                 {set up_to_date_stats "-"; set textuptodate No} \
              else {set up_to_date_stats "+"; set textuptodate Yes};
              send [list fu $up_to_date_stats]}
entry $y7.uptodate.entry -width 17 -font $entryboxfont -textvariable textuptodate
pack $y7.uptodate.label $y7.uptodate.entry -side left
pack $y7.uptodate

frame $y7.buttons
button $y7.buttons.help -text "Help" -width 6 \
   -command { exec xterm -e $browser [join [list $htmlpath F.html] ""] }
button $y7.buttons.change -text "Change" -width 6 \
   -command { if {$unknown != $oldunknown} {send [list "f x" $unknown]}
              if {$format != $oldformat} {send [list "f B" $format]};
              destroy $y7 }
button $y7.buttons.cancel -text "Cancel" -width 6 -command { destroy $y7 }
pack $y7.buttons.help $y7.buttons.change $y7.buttons.cancel -side left
pack $y7.buttons

set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $y7]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $y7]/2 - $fudgefactor]
wm geometry $y7 +$x+$y
}

proc omenu {} {
global y6
global entryboxfont popupbuttonstyle
global wtfilename copyfilename echo textecho copyflag
set y6 .y6
toplevel $y6

label $y6.msg -text "Change Parameters\nSelect Commands" -foreground red -background white -height 3
pack $y6.msg -side top

wm title $y6 " Output Related Commands"
set fudgefactor 100

sendomenu

if {$echo == "+"} {set textecho Yes} else {set textecho No}
frame $y6.echo
button $y6.echo.label -text "Echo Input" -width 12 \
   -command { if {$echo == "+"} \
                 {set echo "-"; set textecho No} \
              else {set echo "+"; set textecho Yes};
              send [list fe $echo]}
entry $y6.echo.echoentry -width 16 -font $entryboxfont -textvariable textecho
pack $y6.echo.label $y6.echo.echoentry -side left
pack $y6.echo

if {$copyflag == "+"} \
   {label $y6.copyfilename -text "Copying I/O to the File: $copyfilename" -fg red -bg white; } \
else {label $y6.copyfilename -text "No Copying of I/O Now" -fg red -bg white}
pack $y6.copyfilename

button $y6.startcopy -text "Start Copying" -width 24 \
   -command { destroy $y6; getval "Enter Filename" ct}
pack $y6.startcopy

button $y6.endcopy -text "End Copying" -width 24 \
   -command { destroy $y6; ccmd "fc-"}
pack $y6.endcopy

frame $y6.wtfname
button $y6.wtfname.label -text "Save Weights To:" -width 12 \
   -command {send [list sw $wtfilename]}
entry $y6.wtfname.entry -width 16 -font $entryboxfont -textvariable wtfilename
bind $y6.wtfname.entry <Return> {send [list sw $wtfilename]}
pack $y6.wtfname.label $y6.wtfname.entry -side left
pack $y6.wtfname

button $y6.savewei2 -text "Save Weights, New File" -width 24 \
   -command { destroy $y6;
              getval "Enter Filename" sw}
pack $y6.savewei2

button $y6.savee -text "Save Everything" -width 24 \
   -command { destroy $y6; getval "Enter Filename" se}
pack $y6.savee

frame $y6.buttons
button $y6.buttons.help -text "Help" -width 6 \
   -command {exec xterm -e $browser [join [list $htmlpath O.html] ""];
             destroy $y6 }
button $y6.buttons.cancel -text "Cancel" -width 6 -command { destroy $y6 }
pack $y6.buttons.help $y6.buttons.cancel -side left
pack $y6.buttons

set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $y6]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $y6]/2 - $fudgefactor]
wm geometry $y6 +$x+$y
}

proc wtsmenu {} {
global y5
global entryboxfont popupbuttonstyle
global wtfilename
set y5 .y5
toplevel $y5

label $y5.msg -text "Read/Write/List Weights" -foreground red -background white -height 3
pack $y5.msg -side top

wm title $y5 " Weights"
set fudgefactor 100

sendwts

frame $y5.save
button $y5.save.label -text "Save Weights To:" -width 20 \
   -command {send [list sw $wtfilename]}
entry $y5.save.entry -width 20 -font $entryboxfont \
   -textvariable wtfilename -fg red -bg white
pack $y5.save.label $y5.save.entry -side left
pack $y5.save

frame $y5.read
button $y5.read.label -text "Read Weights From:" -width 20 \
   -command {send [list rw $wtfilename]}
entry $y5.read.entry -width 20 -font $entryboxfont \
   -textvariable wtfilename -fg red -bg white
pack $y5.read.label $y5.read.entry -side left
pack $y5.read

button $y5.read2 -text "Read Weights, List Files" -width 24 \
   -command { destroy $y5; filelistbox rw}
pack $y5.read2

button $y5.list -text "List Weights Into a Node" -width 24 \
   -command { destroy $y5;
              getval2 "Enter Row";
              tkwait window $newval2;
              set node $val2;
              getval2 "Enter Node";
              tkwait window $newval2;
              send [list w $node $val2]}
pack $y5.list

frame $y5.buttons
button $y5.buttons.help -text "Help" -width 6 \
   -command { exec xterm -e $browser [join [list $htmlpath W.html] ""]}
button $y5.buttons.exit -text "Exit" -width 6 -command { destroy $y5 }
pack $y5.buttons.help $y5.buttons.exit -side left
pack $y5.buttons

set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $y5]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $y5]/2 - $fudgefactor]
wm geometry $y5 +$x+$y
}

proc trainmenu {} {
global y4
global entryboxfont popupbuttonstyle oldrange oldseed oldtoler
global seed printrate maxiter initrange pagesize toler
global oldpagesize
set y4 .y4
toplevel $y4

label $y4.msg -text "Change Parameters\nTrain" -foreground red -background white -height 3
pack $y4.msg -side top

wm title $y4 " Training"
set fudgefactor 100

sendtrain
set oldseed $seed
set oldtoler $toler
set oldpagesize $pagesize

frame $y4.runparam
button $y4.runparam.label -text "Run" \
   -command {destroy $y4; send [list r $maxiter $printrate]}
entry $y4.runparam.maxentry -width 6 -font $entryboxfont \
   -textvariable maxiter -fg red -bg white
label $y4.runparam.label2 -text "Iterations and Print Every"
entry $y4.runparam.printentry -width 6 -font $entryboxfont \
   -textvariable printrate -fg red -bg white
pack $y4.runparam.label $y4.runparam.maxentry $y4.runparam.label2 \
     $y4.runparam.printentry -side left
pack $y4.runparam

frame $y4.seed
label $y4.seed.label -text "Seed Value:"
entry $y4.seed.entry -width 6 -font $entryboxfont -textvariable seed
bind $y4.seed.entry <Return> {set oldseed $seed; send [list s $seed]}
pack $y4.seed.label $y4.seed.entry -side left
pack $y4.seed

frame $y4.range
button $y4.range.label -text "Initialize Weights to +/-:" \
   -command {ccmd [list ci $initrange]}
entry $y4.range.entry -width 6 -font $entryboxfont \
   -textvariable initrange
bind $y4.range.entry <Return> {send [list ci $initrange]}
pack $y4.range.label $y4.range.entry -side left
pack $y4.range

button $y4.clear -text "Set Weights to 0" -width 18 \
   -command { ccmd c}
pack $y4.clear

frame $y4.pagesize
label $y4.pagesize.label -text "Page Size:"
entry $y4.pagesize.entry -width 6 -font $entryboxfont -textvariable pagesize
bind $y4.pagesize.entry <Return> \
   {set oldpagesize $pagesize; send [list fP $pagesize]}
pack $y4.pagesize.label $y4.pagesize.entry -side left
pack $y4.pagesize

frame $y4.toler
label $y4.toler.label -text "Tolerance"
entry $y4.toler.entry -width 6 -font $entryboxfont -textvariable toler
bind $y4.toler.entry <Return> {send [list t $toler]; set oldtoler $toler}
pack $y4.toler.label $y4.toler.entry -side left
pack $y4.toler

frame $y4.buttons
button $y4.buttons.help -text "Help" -width 6 \
   -command { exec xterm -e [join [list $htmlpath T.html] ""]}
button $y4.buttons.change -text "Change" -width 6 \
   -command {if {$pagesize != $oldpagesize} \
                {send [list fP $pagesize]};
             if {$seed != $oldseed} \
                {send [list s $seed]};
             if {$toler != $oldtoler} \
                {send [list t $toler]};
             destroy $y4 }
button $y4.buttons.cancel -text "Exit" -width 6 -command { destroy $y4 }
pack $y4.buttons.help $y4.buttons.change $y4.buttons.cancel -side left
pack $y4.buttons

set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $y4]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $y4]/2 - $fudgefactor]
wm geometry $y4 +$x+$y
}

proc guimenu {} {
global y3
global entryboxfont popupbuttonstyle
global currentfont backgroundcolor textcolor maxlines
global fontname fontcode textvarfont
global oldmaxlines
global bgtextvar textvarfont textcolorvar
global bgcolorname fontname bgcolorcode textcolorname textcolorcode
global pagesize oldpagesize
set y3 .y3
toplevel $y3

label $y3.msg -text "Select Colors and Font\nChange Maximum Lines/Pagesize" -foreground red -background white -height 3
pack $y3.msg -side top

wm title $y3 " GUI Parameters"
set fudgefactor 100

sendgui
set oldmaxlines $maxlines
set oldpagesize $pagesize

set textvarfont $fontname($currentfont)
frame $y3.font
menubutton $y3.font.label -text "Font" -menu $y3.font.label.fonts \
   -width 20 -relief $popupbuttonstyle
entry $y3.font.entry -width 18 -font $entryboxfont -textvariable textvarfont
pack $y3.font.label $y3.font.entry -side left
pack $y3.font
menu $y3.font.label.fonts
$y3.font.label.fonts add command -label $fontname(1) \
   -command { displaytext 1; set textvarfont $fontname(1); ccmd "g f 1"}
$y3.font.label.fonts add separator
$y3.font.label.fonts add command -label $fontname(2) \
   -command { displaytext 2; set textvarfont $fontname(2); ccmd "g f 2"} 
$y3.font.label.fonts add separator
$y3.font.label.fonts add command -label $fontname(3) \
   -command { displaytext 3; set textvarfont $fontname(3); ccmd "g f 3"}
$y3.font.label.fonts add separator
$y3.font.label.fonts add command -label $fontname(4) \
   -command { displaytext 4; set textvarfont $fontname(4); ccmd "g f 4"}
$y3.font.label.fonts add separator
$y3.font.label.fonts add command -label $fontname(5) \
   -command { displaytext 5; set textvarfont $fontname(5); ccmd "g f 5"}
$y3.font.label.fonts add separator
$y3.font.label.fonts add command -label $fontname(6) \
   -command { displaytext 6; set textvarfont $fontname(6); ccmd "g f 6"}
$y3.font.label.fonts add separator
$y3.font.label.fonts add command -label $fontname(7) \
   -command { displaytext 7; set textvarfont $fontname(7); ccmd "g f 7"}

set bgtextvar $bgcolorname($backgroundcolor)
frame $y3.bg
menubutton $y3.bg.label -width 20 -text "Background Color" -menu $y3.bg.label.bgcolor -relief $popupbuttonstyle
entry $y3.bg.entry -width 18 -font $entryboxfont -textvariable bgtextvar
pack $y3.bg.label $y3.bg.entry -side left
pack $y3.bg
# background color menu
menu $y3.bg.label.bgcolor
$y3.bg.label.bgcolor add command -label $bgcolorname(1) \
    -command { .textarea.can config -bg $bgcolorcode(1); \
               set backgroundcolor 1;
               set bgtextvar $bgcolorname(1); ccmd "g b 1" }
$y3.bg.label.bgcolor add separator
$y3.bg.label.bgcolor add command -label $bgcolorname(2) \
    -command { .textarea.can config -bg $bgcolorcode(2); \
               set backgroundcolor 2;
               set bgtextvar $bgcolorname(2); ccmd "g b 2"}
$y3.bg.label.bgcolor add separator
$y3.bg.label.bgcolor add command -label $bgcolorname(3) \
    -command { .textarea.can config -bg $bgcolorcode(3); \
               set backgroundcolor 3;
               set bgtextvar $bgcolorname(3); ccmd "g b 3"}
$y3.bg.label.bgcolor add separator
$y3.bg.label.bgcolor add command -label $bgcolorname(4) \
    -command { .textarea.can config -bg $bgcolorcode(4); \
               set backgroundcolor 4;
               set bgtextvar $bgcolorname(4); ccmd "g b 4"}
$y3.bg.label.bgcolor add separator
$y3.bg.label.bgcolor add command -label $bgcolorname(5) \
    -command { .textarea.can config -bg $bgcolorcode(5); \
               set backgroundcolor 5;
               set bgtextvar $bgcolorname(5); ccmd "g b 5"}
$y3.bg.label.bgcolor add separator
$y3.bg.label.bgcolor add command -label $bgcolorname(6) \
    -command { .textarea.can config -bg $bgcolorcode(6); \
               set backgroundcolor 6;
               set bgtextvar $bgcolorname(6); ccmd "g b 6"}
$y3.bg.label.bgcolor add separator
$y3.bg.label.bgcolor add command -label $bgcolorname(7) \
    -command { .textarea.can config -bg $bgcolorcode(7); \
               set backgroundcolor 7;
               set bgtextvar $bgcolorname(7); ccmd "g b 7"}

set textcolorvar $textcolorname($textcolor)
frame $y3.textcol
menubutton $y3.textcol.label -width 20 -text "Text Color" \
   -menu $y3.textcol.label.tcolormenu -relief $popupbuttonstyle
entry $y3.textcol.entry -width 18 -font $entryboxfont -textvariable textcolorvar
pack $y3.textcol.label $y3.textcol.entry -side left
pack $y3.textcol
# text color menu
menu $y3.textcol.label.tcolormenu
$y3.textcol.label.tcolormenu add command -label $textcolorname(1) \
    -command { set textcolor 1; displaytext $currentfont;
               set textcolorvar $textcolorname(1); ccmd "g t 1" }
$y3.textcol.label.tcolormenu add separator
$y3.textcol.label.tcolormenu add command -label $textcolorname(2) \
    -command { set textcolor 2; displaytext $currentfont;
               set textcolorvar $textcolorname(2); ccmd "g t 2" }
$y3.textcol.label.tcolormenu add separator
$y3.textcol.label.tcolormenu add command -label $textcolorname(3) \
    -command { set textcolor 3; displaytext $currentfont;;
               set textcolorvar $textcolorname(3); ccmd "g t 3" }
$y3.textcol.label.tcolormenu add separator
$y3.textcol.label.tcolormenu add command -label $textcolorname(4) \
    -command { set textcolor 4; displaytext $currentfont;
               set textcolorvar $textcolorname(4); ccmd "g t 4" }
$y3.textcol.label.tcolormenu add separator
$y3.textcol.label.tcolormenu add command -label $textcolorname(5) \
    -command { set textcolor 5; displaytext $currentfont;
               set textcolorvar $textcolorname(5); ccmd "g t 5" }


frame $y3.maxlines
label $y3.maxlines.label -width 21 -text "Maximum Lines"
entry $y3.maxlines.entry -width 18 -font $entryboxfont -textvariable maxlines
bind $y3.maxlines.entry <Return> {send [list g m $maxlines];
                                  newmaxlines $maxlines;
                                  set oldmaxlines $maxlines}
pack $y3.maxlines.label $y3.maxlines.entry -side left
pack $y3.maxlines


frame $y3.pagesize
label $y3.pagesize.label -width 21 -text "Page Size"
entry $y3.pagesize.entry -width 18 -font $entryboxfont -textvariable pagesize
bind $y3.pagesize.entry <Return> {send [list fP $pagesize]; set oldpagesize $pagesize}
pack $y3.pagesize.label $y3.pagesize.entry -side left
pack $y3.pagesize

frame $y3.buttons
button $y3.buttons.change -text "Change" \
   -command { if {$maxlines != $oldmaxlines} {newmaxlines $maxlines; send [list g m $maxlines]};
              if {$pagesize != $oldpagesize} {send [list fP $pagesize]};
              destroy $y3}
button $y3.buttons.cancel -text "Cancel" -command { destroy $y3 }
pack $y3.buttons.change $y3.buttons.cancel -side left -expand yes
pack $y3.buttons

set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $y3]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $y3]/2 - $fudgefactor]
wm geometry $y3 +$x+$y
}

proc amenu {} {
global y2
global entryboxfont popupbuttonstyle
global ah ao deriv update toler
global oldah oldao oldderiv oldupdate oldtoler
global textah textao textderiv algorvar
set y2 .y2
toplevel $y2

label $y2.msg -text "Select Activation Functions\nSelect Derivative\nSelect Update Algorithm\nChange Tolerance" -foreground red -background white -height 5
pack $y2.msg -side top

wm title $y2 " Algorithm Parameters"
set fudgefactor 100

sendalgor
set oldupdate $update
set oldah $ah
set oldao $ao
set oldderiv $deriv
set oldtoler $toler

if {$ah == "l"} {set textah "Linear"} else {set textah "Standard Sigmoid"}
frame $y2.ah
menubutton $y2.ah.label -text "Hidden Layer Activation Function" -menu $y2.ah.label.hidact -width 27 -relief $popupbuttonstyle
entry $y2.ah.entry -width 27 -font $entryboxfont -textvariable textah
pack $y2.ah.label $y2.ah.entry -side left
pack $y2.ah
# hidden layer activation function menu menu for above
menu $y2.ah.label.hidact
$y2.ah.label.hidact add command -label "Standard Sigmoid" \
   -command { set ah s; set textah "Standard Sigmoid"; ccmd "a ahs"}
$y2.ah.label.hidact add separator
$y2.ah.label.hidact add command -label "Linear" \
   -command { set ah l; set textah "Linear"; ccmd "a ahl" }

if {$ao == "l"} {set textao "Linear"} else {set textao "Standard Sigmoid"}
frame $y2.ao
menubutton $y2.ao.label -width 27 -text "Output Layer Activation Function" -menu $y2.ao.label.outact -relief $popupbuttonstyle
entry $y2.ao.entry -width 27 -font $entryboxfont -textvariable textao
pack $y2.ao.label $y2.ao.entry -side left
pack $y2.ao
# output layer activation function menu for above
menu $y2.ao.label.outact
$y2.ao.label.outact add command -label "Standard Sigmoid" \
   -command { set ao s; set textao "Standard Sigmoid"; ccmd "a aos"}
$y2.ao.label.outact add separator
$y2.ao.label.outact add command -label "Linear" \
   -command { set ao l; set textao "Linear"; ccmd "a aol"}

if {$deriv == "c"} {set textderiv "Correct"} \
elseif {$deriv == "d"} {set textderiv "Differential Step Size (1)"} \
else {set textderiv "Fahlman's"}
frame $y2.deriv
menubutton $y2.deriv.label -width 27 -text "Output Layer Derivative" \
   -menu $y2.deriv.label.derivative -relief $popupbuttonstyle
entry $y2.deriv.entry -width 27 -font $entryboxfont -textvariable textderiv
pack $y2.deriv.label $y2.deriv.entry -side left
pack $y2.deriv
# derivative menu for above
menu $y2.deriv.label.derivative
$y2.deriv.label.derivative add command -label "Original Correct Derivative" \
   -command { set deriv "c"; set textderiv "Correct"; ccmd "a dc"}
$y2.deriv.label.derivative add separator
$y2.deriv.label.derivative add command -label "Differential Step Size (1)" \
   -command { set deriv "d"; set textderiv "Differential Step Size (1)";
              ccmd "a dd" }
$y2.deriv.label.derivative add separator
$y2.deriv.label.derivative add command -label "Fahlman's" \
   -command { set deriv "f"; set textderiv "Fahlman's"; ccmd "a df"}

if {$update == "q"} {set algorvar Quickprop} \
elseif {$update == "C"} {set algorvar "Right Continuous"} \
elseif {$update == "c"} {set algorvar "Wrong Continuous"} \
elseif {$update == "p"} {set algorvar "Periodic"} \
elseif {$update == "d"} {set algorvar "Delta-Bar-Delta"} \

frame $y2.update
menubutton $y2.update.label -width 27 -text "Update Algorithm" \
   -menu $y2.update.label.aupdate -relief $popupbuttonstyle
entry $y2.update.updatebox -width 27 -font $entryboxfont -textvariable algorvar
pack $y2.update.label $y2.update.updatebox -side left
pack $y2.update
# algorithm sub-menu menu for the A menu
menu $y2.update.label.aupdate
$y2.update.label.aupdate add command -label "Right Continuous" \
   -command { set update "C"; set algorvar "Right Continuous"; ccmd "auC"}
$y2.update.label.aupdate add separator
$y2.update.label.aupdate add command -label "Wrong Continuous" \
   -command { set update "c"; set algorvar "Wrong Continuous"; ccmd "auc" }
$y2.update.label.aupdate add separator
$y2.update.label.aupdate add command -label "Delta-Bar-Delta" \
   -command { set update "d"; set algorvar "Delta-Bar-Delta"; ccmd "aud"}
$y2.update.label.aupdate add separator
$y2.update.label.aupdate add command -label "Periodic" \
   -command { set update "p"; set algorvar "Periodic"; ccmd "aup" }
$y2.update.label.aupdate add separator
$y2.update.label.aupdate add command -label "Quickprop" \
   -command { set update "q"; set algorvar "Quickprop"; ccmd auq }

frame $y2.toler
label $y2.toler.label -width 27 -text "Tolerance"
entry $y2.toler.entry -width 27 -font $entryboxfont -textvariable toler
bind $y2.toler.entry <Return> {send [list t $toler]; set oldtoler $toler}
pack $y2.toler.label $y2.toler.entry -side left
pack $y2.toler


frame $y2.buttons
button $y2.buttons.help -text "Help" -width 6\
   -command { exec xterm -e $browser [join [list $htmlpath A.html] ""]}
button $y2.buttons.change -text "Change" -width 6\
   -command { if {$toler != $oldtoler} {send [list t $toler]}
              destroy $y2}
button $y2.buttons.cancel -text "Cancel" -width 6 -command { destroy $y2 }
pack $y2.buttons.help $y2.buttons.change $y2.buttons.cancel -side left -expand yes
pack $y2.buttons

set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $y2]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $y2]/2 - $fudgefactor]
wm geometry $y2 +$x+$y
}

proc mktwolayer {} {
global x5
global ninput
global noutput
global entryboxfont
set x5 .x5
toplevel $x5
label $x5.msg -text "Fill In The Blanks\nThen Select Make" -foreground red -background white -height 3

wm title $x5 " Make 2 Layer Net"
set fudgefactor 100

sendnetsize

#if {$wttotal > 0} {
#   set templist [list $wttotal weights];
#   set temp [join $templist " "];
#   label $x5.wttotal -text $temp -height 3;
#   pack $x5.wttotal}
frame $x5.input
label $x5.input.inlabel -width 13 -text "Input Layer"
entry $x5.input.inputentry -width 9 -font $entryboxfont \
   -textvariable ninput -fg red -bg white
frame $x5.output
label $x5.output.outlabel -width 13 -text "Output Layer"
entry $x5.output.outputentry -width 9 -font $entryboxfont \
   -textvariable noutput -fg red -bg white

frame $x5.make2layer
button $x5.make2layer.make -text "Make" \
   -command { set templist [list "m" $ninput $noutput];
              set temp [join $templist " "];
              ccmd $temp;
              destroy $x5 }
button $x5.make2layer.cancel -text "Cancel" -command { destroy $x5 }

pack $x5.msg -side top
pack $x5.input.inlabel $x5.input.inputentry -side left
pack $x5.input
pack $x5.output.outlabel $x5.output.outputentry -side left
pack $x5.output
pack $x5.make2layer.make $x5.make2layer.cancel -side left -expand yes
pack $x5.make2layer
set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $x5]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $x5]/2 - $fudgefactor]
wm geometry $x5 +$x+$y
}

proc mkthreelayer {} {
global x6
global ninput elmantext stmsize
global n1hidden
global noutput
global ioconnects
global entryboxfont
set x6 .x6
toplevel $x6
label $x6.msg -text "Fill In The Blanks\nToggle the Direct I/O Button\nThen Press Make" -foreground red -background white -height 3
frame $x6.make3layer

wm title $x6 " Make 3 Layer Net"
set fudgefactor 100

sendnetsize
set ninput [expr $ninput - $stmsize]
frame $x6.input
label $x6.input.inlabel -width 23 -text "Input Layer"
entry $x6.input.inputentry -width 9 -font $entryboxfont \
   -textvariable ninput -fg red -bg white
frame $x6.hid1
label $x6.hid1.hid1label -width 23 -text "Hidden Layer"
entry $x6.hid1.hid1entry -width 9 -font $entryboxfont \
   -textvariable n1hidden -fg red -bg white
frame $x6.output
label $x6.output.outlabel -width 23 -text "Output Layer"
entry $x6.output.outputentry -width 9 -font $entryboxfont \
   -textvariable noutput -fg red -bg white
frame $x6.ioconnectsframe
button $x6.ioconnectsframe.ioconnectsbutton -width 20 -text "Direct I/O" \
   -command { if {$ioconnects == "No" } {set ioconnects "Yes"} \
              else {set ioconnects "No"} }
entry $x6.ioconnectsframe.ioconnectsentry -width 9 -font $entryboxfont \
   -textvariable ioconnects -fg red -bg white

if {$stmsize == 0} {set elmantext No} else {set elmantext Yes}
frame $x6.elman
button $x6.elman.button -width 20 -text "Elman Recurrent Network" \
   -command { if {$elmantext == "No" } {set elmantext "Yes"} \
              else {set elmantext "No"} }
entry $x6.elman.entry -width 9 -font $entryboxfont \
   -textvariable elmantext -fg red -bg white

button $x6.make3layer.make -text "Make" \
   -command { if { $elmantext == "Yes"} \
                 {
                  set temp1list [list $ninput + $n1hidden];
                  set temp [join $temp1list ""];
                  if { $ioconnects == "Yes"} \
                     { set templist [list "m" $temp $n1hidden $noutput "x"]} \
                  else {set templist [list "m" $temp $n1hidden $noutput]}
                 } \
              else \
                 {
                  if { $ioconnects == "Yes"} \
                     {set templist [list "m" $ninput $n1hidden $noutput "x"];}\
                  else {set templist [list "m" $ninput $n1hidden $noutput]}
                 }

              set temp [join $templist " "];
              ccmd $temp;
              destroy $x6 }
button $x6.make3layer.cancel -text "Cancel" -command { destroy $x6 }
pack $x6.msg -side top
pack $x6.input.inlabel $x6.input.inputentry -side left
pack $x6.input
pack $x6.hid1.hid1label $x6.hid1.hid1entry -side left
pack $x6.hid1
pack $x6.output.outlabel $x6.output.outputentry -side left
pack $x6.output
pack $x6.ioconnectsframe.ioconnectsbutton $x6.ioconnectsframe.ioconnectsentry -side left
pack $x6.ioconnectsframe
pack $x6.elman.button $x6.elman.entry -side left
pack $x6.elman
pack $x6.make3layer.make $x6.make3layer.cancel -side left -expand yes
pack $x6.make3layer
set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $x6]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $x6]/2 - $fudgefactor]
wm geometry $x6 +$x+$y
}

proc mkfourlayer {} {
global x7
global ninput elmantext stmsize
global n1hidden
global n2hidden
global noutput
global ioconnects
global entryboxfont
set x7 .x7
toplevel $x7
label $x7.msg -text "Fill In The Blanks\nToggle the Direct I/O Button\nThen Press Make" -foreground red -background white -height 3
frame $x7.make4layer

wm title $x7 " Make 4 Layer Net"
set fudgefactor 100

sendnetsize
set ninput [expr $ninput - $stmsize]
frame $x7.input
label $x7.input.inlabel -width 23 -text "Input Layer"
entry $x7.input.inputentry -width 9 -font $entryboxfont \
   -textvariable ninput -fg red -bg white
frame $x7.hid1
label $x7.hid1.hid1label -width 23 -text "Hidden Layer"
entry $x7.hid1.hid1entry -width 9 -font $entryboxfont \
   -textvariable n1hidden -fg red -bg white
frame $x7.hid2
label $x7.hid2.hid2label -width 23 -text "Second Hidden"
entry $x7.hid2.hid2entry -width 9 -font $entryboxfont \
   -textvariable n2hidden -fg red -bg white
frame $x7.output
label $x7.output.outlabel -width 23 -text "Output Layer"
entry $x7.output.outputentry -width 9 -font $entryboxfont \
   -textvariable noutput -fg red -bg white
frame $x7.ioconnectsframe
button $x7.ioconnectsframe.ioconnectsbutton -width 20 -text "Direct I/O" \
   -command { if {$ioconnects == "No" } {set ioconnects "Yes"} \
              else {set ioconnects "No"} }
if {$ioconnects == "unset"} {set ioconnects "No"}
entry $x7.ioconnectsframe.ioconnectsentry -width 9 -font $entryboxfont \
   -textvariable ioconnects -fg red -bg white

if {$stmsize == 0} {set elmantext No} else {set elmantext Yes}
frame $x7.elman
button $x7.elman.button -width 20 -text "Elman Recurrent Network" \
   -command { if {$elmantext == "No" } {set elmantext "Yes"} \
              else {set elmantext "No"} }
entry $x7.elman.entry -width 9 -font $entryboxfont \
   -textvariable elmantext -fg red -bg white

button $x7.make4layer.make -text "Make" \
   -command { if { $elmantext == "Yes"} \
                 {
                  set temp1list [list $ninput + $n1hidden];
                  set temp [join $temp1list ""];
                  if { $ioconnects == "Yes"} \
                     { set templist [list "m" $temp $n1hidden $n2hidden $noutput "x"]} \
                  else {set templist [list "m" $temp $n1hidden $n2hidden $noutput]}
                 } \
              else \
                 {
                  if { $ioconnects == "Yes"} \
                     {set templist [list "m" $ninput $n1hidden $n2hidden $noutput "x"];}\
                  else {set templist [list "m" $ninput $n1hidden $n2hidden $noutput]}
                 }

              set temp [join $templist " "];
              ccmd $temp;
              destroy $x7 }
button $x7.make4layer.cancel -text "Cancel" -command { destroy $x7 }
pack $x7.msg -side top
pack $x7.input.inlabel $x7.input.inputentry -side left
pack $x7.input
pack $x7.hid1.hid1label $x7.hid1.hid1entry -side left
pack $x7.hid1
pack $x7.hid2.hid2label $x7.hid2.hid2entry -side left
pack $x7.hid2
pack $x7.output.outlabel $x7.output.outputentry -side left
pack $x7.output
pack $x7.ioconnectsframe.ioconnectsbutton $x7.ioconnectsframe.ioconnectsentry -side left
pack $x7.ioconnectsframe
pack $x7.elman.button $x7.elman.entry -side left
pack $x7.elman
pack $x7.make4layer.make $x7.make4layer.cancel -side left -expand yes
pack $x7.make4layer
set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $x7]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $x7]/2 - $fudgefactor]
wm geometry $x7 +$x+$y
}

proc gradmenu {} {
global x8
global entryboxfont
global update eta eta2 alpha
global oldupdate oldeta oldeta2 oldalpha
global algorCvar algorcvar algorpvar
set x8 .x8
toplevel $x8

label $x8.msg -text "Change Values\nToggle Gradient Descent On" -foreground red -background white -height 3
pack $x8.msg -side top

wm title $x8 " Gradient Descent"
set fudgefactor 100

sendgrad
set oldupdate $update
set oldeta $eta
set oldeta2 $eta2
set oldalpha $alpha

frame $x8.eta
label $x8.eta.label -width 24 -text "Upper Level Eta"
entry $x8.eta.entry -width 9 -font $entryboxfont -textvariable eta
bind $x8.eta.entry <Return> {send [list e $eta $eta2]; set oldeta $eta}
pack $x8.eta.label $x8.eta.entry -side left
pack $x8.eta

frame $x8.eta2
label $x8.eta2.label -width 24 -text "Lower Level Eta"
entry $x8.eta2.entry -width 9 -font $entryboxfont -textvariable eta2
bind $x8.eta2.entry <Return> {send [list e $eta $eta2]; set oldeta2 $eta2}
pack $x8.eta2.label $x8.eta2.entry -side left
pack $x8.eta2

frame $x8.alpha
label $x8.alpha.label -width 24 -text "Momentum Term"
entry $x8.alpha.entry -width 9 -font $entryboxfont -textvariable alpha
bind $x8.alpha.entry <Return> {send [list a $alpha]; set oldalpha $alpha}
pack $x8.alpha.label $x8.alpha.entry -side left
pack $x8.alpha

if {$update == "C"} {
   set algorCvar Yes;
   set algorcvar No;
   set algorpvar No; } \
elseif {$update == "c"} {
   set algorCvar No;
   set algorcvar Yes;
   set algorpvar No; } \
elseif {$update == "p"} {
   set algorCvar No;
   set algorcvar No;
   set algorpvar Yes; } \
else {set algorCvar No; set algorcvar No; set algorpvar No}

frame $x8.updateC
button $x8.updateC.label -width 21 -text "Using Right Continuous" \
   -command { set algorCvar "Yes";
              set algorcvar No;
              set algorpvar No;
              set update C;
              set oldupdate $update;
              ccmd "a uC"}
entry $x8.updateC.updateCbox -width 9 -font $entryboxfont -textvariable algorCvar
pack $x8.updateC.label $x8.updateC.updateCbox -side left
pack $x8.updateC

frame $x8.updatec
button $x8.updatec.label -width 21 -text "Using Wrong Continuous" \
   -command { set algorCvar No;
              set algorcvar Yes;
              set algorpvar No;
              set update c;
              set oldupdate $update;
              ccmd "a uc"}
entry $x8.updatec.updatecbox -width 9 -font $entryboxfont -textvariable algorcvar
pack $x8.updatec.label $x8.updatec.updatecbox -side left
pack $x8.updatec

frame $x8.updatep
button $x8.updatep.label -width 21 -text "Using Periodic" \
   -command { set algorCvar No;
              set algorcvar No;
              set algorpvar Yes;
              set update p;
              set oldupdate $update;
              ccmd "a up"}
entry $x8.updatep.updatepbox -width 9 -font $entryboxfont -textvariable algorpvar
pack $x8.updatep.label $x8.updatep.updatepbox -side left
pack $x8.updatep

frame $x8.gradbuttons
button $x8.gradbuttons.help -text "Help" -width 6 \
   -command { exec xterm -e $browser [join [list $htmlpath G.html ] ""]}
button $x8.gradbuttons.ok -text "Change" -width 6 \
   -command { if {$update != $oldupdate} {send [list "a u" $update]}
              if {$oldalpha != $alpha} {send [list "a" $alpha"]}
              if {$oldeta != $eta || $oldeta2 != $eta2} \
                 {send [list e $eta $eta2]}
              destroy $x8}
button $x8.gradbuttons.cancel -text "Cancel" -width 6 -command { destroy $x8 }
pack $x8.gradbuttons.help $x8.gradbuttons.ok $x8.gradbuttons.cancel -side left -expand yes
pack $x8.gradbuttons

set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $x8]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $x8]/2 - $fudgefactor]
wm geometry $x8 +$x+$y
}

proc qpmenu {} {
global x9
global entryboxfont
global qpdecayh qpdecayo qpeta mu qpslope update oldslope
global oldupdate olddecayh olddecayo oldeta oldmu
global algorqvar slopevar
set x9 .x9
toplevel $x9

label $x9.msg -text "Change Values\nToggle Slope\nSwitch Quickprop On" -foreground red -background white -height 4
pack $x9.msg -side top

wm title $x9 " Quickprop Parameters"
set fudgefactor 100

sendqp
set oldupdate $update
set oldeta $qpeta
set oldmu $mu
set olddecayh $qpdecayh
set olddecayo $qpdecayo
set oldslope $qpslope

frame $x9.decayh
label $x9.decayh.label -width 24 -text "Hidden Layer Decay"
entry $x9.decayh.entry -width 9 -font $entryboxfont -textvariable qpdecayh
bind $x9.decayh.entry <Return> {send [list qp dh $qpdecayh]; set olddecayh $qpdecayh}
pack $x9.decayh.label $x9.decayh.entry -side left
pack $x9.decayh

frame $x9.decayo
label $x9.decayo.label -width 24 -text "Output Layer Decay"
entry $x9.decayo.entry -width 9 -font $entryboxfont -textvariable qpdecayo
bind $x9.decayo.entry <Return> {send [list qp do $qpdecayo]; set olddecayo $qpdecayo}
pack $x9.decayo.label $x9.decayo.entry -side left
pack $x9.decayo

frame $x9.eta
label $x9.eta.label -width 24 -text "Eta"
entry $x9.eta.entry -width 9 -font $entryboxfont -textvariable qpeta
bind $x9.eta.entry <Return> {send [list "qp e" $qpeta]; set oldeta $qpeta}
pack $x9.eta.label $x9.eta.entry -side left
pack $x9.eta

frame $x9.mu
label $x9.mu.label -width 24 -text "Mu"
entry $x9.mu.entry -width 9 -font $entryboxfont -textvariable mu
bind $x9.mu.entry <Return> {send [list "qp m" $mu]; set oldmu $mu}
pack $x9.mu.label $x9.mu.entry -side left
pack $x9.mu

if {$update == "q"} {set algorqvar Yes} else {set algorqvar No}
if {$qpslope == "+"} {set slopevar Yes} else {set slopevar No}

frame $x9.qpslope
button $x9.qpslope.label -width 21 -text "Using Extra Slope Term" \
   -command { if {$slopevar == "No" } \
                 {set slopevar "Yes";
                  set qpslope "+";
                  send [list qp s $qpslope];
                  set oldslope $qpslope} \
              else {set slopevar No;
                    set qpslope "-";
                    send [list qp s $qpslope];
                    set oldslope $qpslope}}

entry $x9.qpslope.entry -width 9 -font $entryboxfont -textvariable slopevar
pack $x9.qpslope.label $x9.qpslope.entry -side left
pack $x9.qpslope

frame $x9.update
button $x9.update.label -width 21 -text "Using Quickprop" \
   -command { if {$algorqvar == "No"} \
                 {set algorqvar Yes;
                  set update q;
                  ccmd "a uq"} }
entry $x9.update.updatebox -width 9 -font $entryboxfont -textvariable algorqvar
pack $x9.update.label $x9.update.updatebox -side left
pack $x9.update

frame $x9.buttons
button $x9.buttons.help -text "Help" -width 6 \
   -command { exec xterm -e $browser [join [list $htmlpath Q.html] ""]}
button $x9.buttons.change -text "Change" -width 6 \
   -command { if {$update != $oldupdate} {send [list "a u" $update};
              if {$oldeta != $qpeta} {send [list qp e $qpeta]};
              if {$oldmu != $mu} {send [list qp m $mu]};
              if {$olddecayh != $qpdecayh} {send [list qp dh $qpdecayh]};
              if {$olddecayo != $qpdecayo} {send [list qp do $qpdecayo]};
              if {$oldslope != $qpslope} {send [list qp s $qpslope]};
   
              destroy $x9}
button $x9.buttons.cancel -text "Cancel" -width 6 -command { destroy $x9 }
pack $x9.buttons.help $x9.buttons.change $x9.buttons.cancel -side left -expand yes
pack $x9.buttons

set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $x9]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $x9]/2 - $fudgefactor]
wm geometry $x9 +$x+$y
}

proc dbdmenu {} {
global y1
global entryboxfont
global decay dbdeta kappa theta1 etamax update
global oldupdate olddecay oldeta oldkappa oldmax oldtheta1
global algordvar slopevar
set y1 .y1
toplevel $y1

label $y1.msg -text "Change Values\nSwitch DBD On" -foreground red -background white -height 4
pack $y1.msg -side top

wm title $y1 " Delta-Bar-Delta Parameters"
set fudgefactor 100

senddbd
set oldupdate $update
set olddecay $decay
set oldeta $dbdeta
set oldkappa $kappa
set oldmax $etamax
set oldtheta1 $theta1

frame $y1.decay
label $y1.decay.label -width 24 -text "DBD Decay"
entry $y1.decay.entry -width 9 -font $entryboxfont -textvariable decay
bind $y1.decay.entry <Return> {send [list d d $decay]; set olddecay $decay}
pack $y1.decay.label $y1.decay.entry -side left
pack $y1.decay

frame $y1.dbdeta
label $y1.dbdeta.label -width 24 -text "DBD Eta"
entry $y1.dbdeta.entry -width 9 -font $entryboxfont -textvariable dbdeta
bind $y1.dbdeta.entry <Return> {send [list d e $dbdeta]; set oldeta $dbdeta}
pack $y1.dbdeta.label $y1.dbdeta.entry -side left
pack $y1.dbdeta

frame $y1.kappa
label $y1.kappa.label -width 24 -text "Kappa"
entry $y1.kappa.entry -width 9 -font $entryboxfont -textvariable kappa
bind $y1.kappa.entry <Return> {send [list d k $kappa]; set oldkappa $kappa}
pack $y1.kappa.label $y1.kappa.entry -side left
pack $y1.kappa

frame $y1.maxeta
label $y1.maxeta.label -width 24 -text "Maximum Eta"
entry $y1.maxeta.entry -width 9 -font $entryboxfont -textvariable etamax
bind $y1.maxeta.entry <Return> {send [list d m $etamax]; set oldmax $etamax}
pack $y1.maxeta.label $y1.maxeta.entry -side left
pack $y1.maxeta

frame $y1.theta1
label $y1.theta1.label -width 24 -text "Theta"
entry $y1.theta1.entry -width 9 -font $entryboxfont -textvariable theta1
bind $y1.theta1.entry <Return> {send [list d t $theta1]; set oldtheta $theta1}
pack $y1.theta1.label $y1.theta1.entry -side left
pack $y1.theta1

if {$update == "d"} {set algordvar Yes} else {set algordvar No}

frame $y1.update
button $y1.update.label -width 21 -text "Using Delta-Bar-Delta" \
   -command { if {$algordvar == "No"} \
                 {set algordvar Yes; set update d; ccmd "a ud"} }
entry $y1.update.updatebox -width 9 -font $entryboxfont -textvariable algordvar
pack $y1.update.label $y1.update.updatebox -side left
pack $y1.update

frame $y1.buttons
button $y1.buttons.help -text "Help" -width 6 \
   -command { exec xterm -e $browser [join [list $htmlpath D.html] ""]}
button $y1.buttons.change -text "Change" -width 6 \
   -command { if {$update != $oldupdate} {ccmd "a ud"}
              if {$olddecay != $decay} {send [list a d $decay]}
              if {$oldeta != $dbdeta} {send [list a d $dbdeta]}
              if {$oldkappa != $kappa} {send [list a k $kappa]}
              if {$oldmax != $etamax} {send [list a m $etamax]}
              if {$oldtheta1 != $theta1} {send [list a t $theta1]}
              destroy $y1}
button $y1.buttons.cancel -text "Cancel" -width 6 -command { destroy $y1 }
pack $y1.buttons.help $y1.buttons.change $y1.buttons.cancel -side left -expand yes
pack $y1.buttons

set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $y1]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $y1]/2 - $fudgefactor]
wm geometry $y1 +$x+$y
}

proc my_popup {wind} {
set yfudgefactor 0
set xfudgefactor 100
set x [expr [winfo rootx .] + $xfudgefactor]
set y [expr [winfo rooty .] + [winfo height .f]]
tk_popup $wind $x $y
}

proc filelistbox {op} {
global operation
global xxx
global globalfilename
set operation $op
set xxx .x3
toplevel $xxx
label $xxx.msg -text "Double Click the Desired File" -foreground red -background white -height 3
pack $xxx.msg -side top
frame $xxx.filebox
scrollbar $xxx.filebox.sy -orient vert -command "$xxx.filebox.box yview"
scrollbar $xxx.filebox.sx -orient horiz -command "$xxx.filebox.box xview"
pack $xxx.filebox.sy -side right -fill y
pack $xxx.filebox.sx -side bottom -fill x
listbox $xxx.filebox.box -xscroll "$xxx.filebox.sx set" \
                         -yscroll "$xxx.filebox.sy set" \
                         -relief sunken -width 20 -height 20 \
	                 -setgrid yes -selectmode browse
pack $xxx.filebox.box -side left -fill both -expand yes
pack $xxx.filebox

wm title $xxx " Filenames"
set fudgefactor 100
set x [expr [winfo width .]/2 + [winfo rootx .] - [winfo reqwidth $xxx]/2]
set y [expr [winfo height .]/2 + [winfo rooty .] - [winfo reqheight $xxx]/2 - $fudgefactor]
wm geometry $xxx +$x+$y

# Fill the listbox with a list of all the files in the directory (run
# the "ls" command to get that information).

set dir "."
foreach i [exec ls $dir] { $xxx.filebox.box insert end $i }

bind $xxx.filebox.box <Double-Button-1> \
     {set globalfilename [selection get];
      set cmdlist2 [list $operation $globalfilename];
      set cmd2 [join $cmdlist2 " "];
      ccmd $cmd2; destroy $xxx}

}

### set up the menu frame window .f together with the menu items ###

frame .f
menubutton .f.file -text "File" -menu .f.file.z -relief $popupbuttonstyle
menu .f.file.z
.f.file.z add command -label "Read Commands File" -command { filelistbox "i" }
.f.file.z add separator
.f.file.z add command -label "Change Directory" \
    -command { getval "New Directory:" "cd"}
.f.file.z add separator
.f.file.z add command -label "Copy I/O" \
   -command { getval "Enter Filename" "ct" }
.f.file.z add separator
.f.file.z add command -label "End Copying" -command { ccmd "fc-" }
.f.file.z add separator
.f.file.z add command -label "Save As ... " \
   -command { getval "Enter Filename" "se"; tkwait window $newval}
.f.file.z add separator
.f.file.z add command -label "Save and Exit" \
   -command { getval "Enter Filename" "se"; tkwait window $newval; ccmd q}
.f.file.z add separator
if {$executable == "/usr/bin/wish"} \
   {.f.file.z add command -label "Exit, No Save" -command exit} \
else {.f.file.z add command -label "Exit, No Save" -command "ccmd q"}

button .f.gui -text "GUI" -relief $popupbuttonstyle -command guimenu

# The Commands Menu

menubutton .f.cmds -text "Commands" -menu .f.cmds.z -relief $popupbuttonstyle
menu .f.cmds.z
.f.cmds.z add command -label "A\tAlgorithm Parameters and Tolerance" \
   -command amenu
.f.cmds.z add separator
.f.cmds.z add command -label "D\tDelta-Bar-Delta Parameters" -command dbdmenu
.f.cmds.z add separator
.f.cmds.z add command -label "F\tFormats" -command fmenu
.f.cmds.z add separator
.f.cmds.z add command -label "G\tGradient Descent (plain backprop)" \
   -command gradmenu
.f.cmds.z add separator
.f.cmds.z add command -label "I\tInput Commands, Change Input Formats" \
   -command imenu
.f.cmds.z add separator
.f.cmds.z add command -label "N\tNetwork Commands" -command nmenu
.f.cmds.z add separator
.f.cmds.z add command -label "O\tOutput Commands, Output Formats" \
   -command omenu
.f.cmds.z add separator
.f.cmds.z add command -label "P\tReading Patterns, Evaluating Patterns" \
   -command patmenu
.f.cmds.z add separator
.f.cmds.z add command -label "Q\tQuickprop Parameters" -command qpmenu
.f.cmds.z add separator
.f.cmds.z add command -label "T\tTraining Commands: Seed Value, Clear, Initialize, Run" \
   -command trainmenu
.f.cmds.z add separator
.f.cmds.z add command -label "W\tWeights Commands" -command wtsmenu


button .f.amenu -relief $popupbuttonstyle -text A -command amenu
#button .f.bmenu -relief $popupbuttonstyle -text B -command bmenu
button .f.dmenu -relief $popupbuttonstyle -text D -command dbdmenu
button .f.fmenu -relief $popupbuttonstyle -text F -command fmenu
button .f.gmenu -relief $popupbuttonstyle -text G -command gradmenu
button .f.imenu -relief $popupbuttonstyle -text I -command imenu
button .f.nmenu -text N -relief $popupbuttonstyle -command nmenu
button .f.omenu -relief $popupbuttonstyle -text O -command omenu
button .f.pmenu -relief $popupbuttonstyle -text P -command patmenu
button .f.qmenu -relief $popupbuttonstyle -text Q -command qpmenu
button .f.rmenu -relief $popupbuttonstyle -text R -command rpmenu
button .f.smenu -relief $popupbuttonstyle -text S -command ssmenu
button .f.tmenu -relief $popupbuttonstyle -text T -command trainmenu
button .f.wmenu -relief $popupbuttonstyle -text W -command wtsmenu
button .f.help -relief $popupbuttonstyle -text "Help" \
   -command {exec xterm -e $browser [join [list $htmlpath bp.html] ""]}
#   -command {set nonsense [join [list $helpcmd bp.html] ""];
#             puts $nonsense;
#             exec $nonsense}

#never used, I don't know what I'm doing
#button .f.stop -relief $popupbuttonstyle -text STOP \
#   -command {set stoptrain 1}

# never used
proc tcltkstop { } {
global stoptrain
set $stoptrain "1"
return "1"
}

pack .f.file .f.gui .f.cmds .f.amenu .f.dmenu .f.fmenu .f.gmenu \
     .f.imenu .f.nmenu .f.omenu .f.pmenu .f.qmenu .f.tmenu \
     .f.wmenu .f.help -side left

# the second row of menu items, just simple commands

frame .b
button .b.sys -text "!" -relief $buttonbuttonstyle -command "ccmd !"
button .b.qm -text "?" -relief $buttonbuttonstyle -command "ccmd ?"
button .b.sci -text "sci" -relief $buttonbuttonstyle -command {ccmd s; ccmd ci}
button .b.ci -text "ci" -relief $buttonbuttonstyle -command "ccmd ci"
button .b.run -text "r" -relief $buttonbuttonstyle -command "ccmd r"
button .b.input -text "i" -relief $buttonbuttonstyle -command "ccmd i"
button .b.pat -text "p" -relief $buttonbuttonstyle -command "ccmd p"
button .b.testpat -text "t" -relief $buttonbuttonstyle -command "ccmd t"
button .b.upat -text "u" -relief $buttonbuttonstyle -command "ccmd u"
button .b.vtestpat -text "v" -relief $buttonbuttonstyle -command "ccmd v"
button .b.sw -text "sw" -relief $buttonbuttonstyle -command "ccmd sw"
button .b.rw -text "rw" -relief $buttonbuttonstyle -command "ccmd rw"
button .b.stop -text "Stop" -relief $buttonbuttonstyle -command "stopcmd"

#free version
pack .b.qm .b.sci .b.ci .b.run .b.pat .b.testpat .b.sw .b.rw .b.stop -side left

frame .textarea -relief sunken

# scroll bars for the canvas area

scrollbar .hsb  -relief sunken -orient horiz -command ".textarea.can xview"
scrollbar .textarea.vsb  -relief sunken -orient vertical -command ".textarea.can yview"

# the entry box, it sends commands to the C program

entry .entrybox -width $windwidth -font $entryboxfont -textvariable cmd
bind .entrybox <Return> { ccmd $cmd; set cmd "" }
# if {cmd == "A"}{amenu} \
#                          elseif {cmd == "D"}{dbdmenu} \
#                          elseif {cmd == "F"}{fmenu} \
#                          elseif {cmd == "G"}{gradmenu} \
#                          elseif {cmd == "I"}{imenu} \
#                          elseif {cmd == "N"}{nmenu} \
#                          elseif {cmd == "O"}{omenu} \
#                          elseif {cmd == "P"}{patmenu} \
#                          elseif {cmd == "Q"}{qpmenu} \
#                          elseif {cmd == "T"}{trainmenu} \
#                          elseif {cmd == "W"}{wtsmenu} \

# the canvas area where I/O shows up

set entryboxheight [winfo reqheight .entrybox]
set hscrollbarheight [winfo reqheight .hsb]
set frameheight [winfo reqheight .f]
set bframeheight [winfo reqheight .b]
set fudgefactor 80
set canvas_height [expr $windheight - $frameheight -$bframeheight -$entryboxheight -$hscrollbarheight -$fudgefactor ]
set dumblist [list 0 0 $scrollwidth $scrollheight]
set vscrollbarwidth [winfo reqwidth .textarea.vsb]
set canvas_width [expr $windwidth - $vscrollbarwidth]
canvas .textarea.can -width $canvas_width -height $canvas_height -xscrollcommand ".hsb set" -yscrollcommand ".textarea.vsb set" -scrollregion  $dumblist  -relief sunken -bg $bgcolorcode($backgroundcolor)

# pack stuff (new)
#
pack .f -fill x
pack .b -fill x
pack .textarea.vsb -fill y -side right
pack .textarea.can -expand yes -fill both
pack .textarea -expand yes -fill both
pack .entrybox -fill x
pack .hsb -fill x
pack propagate .textarea.can yes
pack propagate .textarea yes

set i 0
while { $i < $tkmaxlines } {
   set txt($i) " "
   incr i 1
   }
set newlinehere 0
displaytext $currentfont
if {$cmdfilename != "//"} {send [list i $cmdfilename]}
